var wifi={
    uploadList:[],
    uploadIndex:0,
    isUploading:false,
    getStyle:function(obj,name){
        if(obj.currentStyle){
            return obj.currentStyle[name];
        }else{
            return getComputedStyle(obj,false)[name];
        }
    },
    Move:function(obj,attr,iTarget,sfunc){
        clearInterval(obj.timer);
        obj.timer=setInterval(function(){
            var cur=0;
            if(attr=="opacity"){
                cur=Math.round(parseFloat(wifi.getStyle(obj,attr))*100);
            }else{
                cur=parseInt(wifi.getStyle(obj,attr));
            }
            var speed=(iTarget-cur)/10;
            speed=speed>0?Math.ceil(speed):Math.floor(speed);
            speed=-5;
            if(iTarget==cur){
                clearInterval(obj.timer);
                if(sfunc){
                    sfunc();
                }
            }else{
                cur+=speed;
                if(attr=="opacity"){
                    obj.style.filter="alpha(opacity:"+cur+")";
                    obj.style.opacity=cur/100;
                }else{
                    obj.style[attr]=cur+"px";
                    var pobj=$(obj).parent('ul');
                }
            }
        },30);
    },
    removeLi:function(pDom){
        pDom.css('backgroundColor','#00B37B');
        setTimeout(function(){
            wifi.Move(pDom[0],'height',0,function(){pDom.remove();});
        },200)
    },
   
    // 初始化列表的高度
    initPageList:function(){
		var oHeight=$('.head').outerHeight()+$('.cont_a').outerHeight()+85+10;
		var num=parseInt(($(window).outerHeight()-oHeight)/50)
        $('#filesList').css({height:num*50})
    },
    // 加载服务器端文件列表
    loadFileList:function(){
        $.getJSON('?_dc='+new Date().getTime()+'&action=getbooklist',function(data,status){
        	if(data.status==0){
                $("#filesList").empty();
                var list=$.parseJSON(data.filelist);
                if(!list){return}
                for(var i=0;i<list.length;i++){
                    var cb=list[i];
                    wifi.addFileListHtml(cb.name,cb.time,wifi.unitTranslated(cb.size),cb.url,false,true);
                }
            }
        })
    },
    // 绑定上传按钮样式
    setUploadView:function(){
        var upbtn=$('#chooseFileBtn');
        $('.cont_a_l p').mouseover(function(){upbtn.addClass('on');})
            .mouseout(function(){upbtn.removeClass('on')})
            .mousedown(function(){upbtn.removeClass('on');})
    },
    checkName:function checkFileName(fileName) {
        if (!fileName || !fileName.toLowerCase().match('(epub)$')) {
            return '请选择epub文件。';
        }
        var arr = fileName.split("\\");
        fileName = arr[arr.length - 1];
        var hasFile = false;
        var existFile = $("#filesList li[bookName='" + escape(fileName) + "']");
        if (existFile.length > 0) {
            return '文件列表中已经包含“'+fileName+'”';
        }
        return '';
    },
    // 绑定控件上传方式
    bindUploadBtn:function(inputSelector){
        var me=wifi;
        $(inputSelector).unbind();
        $(inputSelector).change(function() {
            var fileName = $(this).val(),msg = me.checkName(fileName);
            if (msg) {$(this).val();alert(msg);return;}
            var arr = fileName.split("\\");
            fileName = arr[arr.length - 1];
            if(!me.isUploading){
                me.addFileListHtml(fileName,'','','',true,false);
            }else{
                alert("正在上传，请您稍候再继续！");
            }
            me.uploadList.push(inputSelector);
            $(inputSelector).css({ top: '-5000px', left: '-5000px' });
            $('.cont_a_l p').append('<input type="file" name="file" id="file_'+me.uploadList.length+'">');
            me.bindUploadBtn('#file_'+me.uploadList.length);
            me.startH4Upload();
		 });
    },
    startH4Upload:function() {
        var me=wifi;
        if(me.uploadIndex>=me.uploadList.length||me.isUploading){return}
        me.isUploading=true;
        var eleFile = $(me.uploadList[me.uploadIndex]),
        eleFileId = eleFile.attr('id'),
        fileName = eleFile.val(),
        arr = fileName.split("\\");
        fileName = arr[arr.length - 1];
        me.uploadIndex++;
        var cli=$('li[bookName="'+escape(fileName)+'"]');
        cli.find('.f_note').html('上传中<img src="/images/loading.gif" width="32" style="margin-left:15px;"/>');
     
        $.getJSON('?_dc='+new Date().getTime()+'&action=beforeupload',function(data){
            if(data.status==0){
                  $.ajaxFileUpload({
                                   url:'?_dc='+new Date().getTime()+'&action=upload',
                                   secureuri:false,
                                   fileElementId:eleFileId,
                                   dataType: 'xml',
                                   success: function (data, status) {
                                   me.isUploading=false;
                                   me.loadFileList();
                                   },
                                   error: function (data, status, e) {
                                   me.isUploading=false;
                                   cli[0].style.color='red';
                                   }
                                   });
            }
        });
                  
    },
    
    
	// 上传文件后添加列表结构
	addFileListHtml:function(bookName,uploadTime,bookSize,url,hasNote,cancelShow){
        var doms=[];
        doms.push('<li bookName="'+escape(bookName)+'"><span class="long"><i><em></em></i><b>'+bookName+'</b></span>');
        doms.push('<span>'+(Boolean(uploadTime)?uploadTime:'--')+'</span><span>'+(Boolean(bookSize)?(bookSize):'--')+'</span>');
        doms.push('<span class="rowevenicon">');
        doms.push('<b class="f_note" style="display: '+(Boolean(hasNote)?'initial':'none')+'">等待中</b>');
        doms.push('<b style="display: '+(Boolean(cancelShow)?'initial':'none')+'">已上传</b>');
        doms.push('</span></li>');
        var li=$(doms.join(''));
        $("#filesList").prepend(li);
        return li;
	},
	// 上传文件失败后列表样式变化
	failAddFileListHtml:function(classname){
		// 上传失败时样式变化 还未确认
	},
	// 单位转化
	unitTranslated:function(value) {
	    var multiplyFactor = 0;
	    var fileUnit = ["bytes","KB","MB","GB","TB"];
    
	    while (value > 1024) {
	        value /= 1024;
	        multiplyFactor++;
	    }    
	    return value.toFixed(1) + " " + fileUnit[multiplyFactor];
	},
    formatTime:function(format){
        var o = {
            "M+" : this.getMonth()+1, // month
            "d+" : this.getDate(), // day
            "h+" : this.getHours(), // hour
            "m+" : this.getMinutes(), // minute
            "s+" : this.getSeconds(), // second
            "q+" : Math.floor((this.getMonth()+3)/3), // quarter
            "S" : this.getMilliseconds() // millisecond
        }
        if(/(y+)/.test(format)) format=format.replace(RegExp.$1,
            (this.getFullYear()+"").substr(4- RegExp.$1.length));
        for(var k in o)if(new RegExp("("+ k +")").test(format))
            format = format.replace(RegExp.$1,
                RegExp.$1.length==1? o[k] :
                    ("00"+ o[k]).substr((""+ o[k]).length));
        return format;
    },
    removeFialItem:function(){
        var dom=$('.f_download');
        for(var i=dom.length-1;i>=0;i--){
            var cdom=dom.eq(i);
            if(cdom.css('display')=='none'){
                var cli=cdom.closest('li');
                var cNote=cli.find('.f_note');
                if(cNote.css('display')!='none'){
                    if(cNote.html()=="等待中"){
                        (function(meLi){setTimeout(function(){meLi.remove()},600)})(cli);
                    }else{
                        cli.find('.long em').width(0);
                        (function(meLi){wifi.removeLi(meLi);})(cli);
                    }
                }
            }
        }
    }

}
$(document).ready(function(){
    // 根据是否支持H5来选择页面展示内容，如果支持则展示拖拽区域并绑定拖拽事件
    wifi.setUploadView();
    wifi.bindUploadBtn('#file');
    // 初始化图书列表的高度
    wifi.initPageList();
    $(window).resize(function() {
        wifi.initPageList();
    });
    // 获取服务端文件列表
    wifi.loadFileList();
                  
    $(document).ajaxError(function(event, request, settings){
        alert('无法连接WiFi传书服务器，请重新打开WiFi传书服务并刷新此页后重新上传。');
        wifi.removeFialItem();
    });

    $.handleError=function(s, xhr, status, e) { if (s.error) { s.error.call(s.context || s, xhr, status, e); }if (s.global) {(s.context ? jQuery(s.context) : jQuery.event).trigger("ajaxError", [xhr, s, e]); } }
    $.httpData=function( xhr, type, s ) { var ct = xhr.getResponseHeader( "content-type"), xml = type == "xml" || !type && ct && ct.indexOf( "xml" ) >=0, data = xml ? xhr.responseXML: xhr.responseText; if ( xml && data.documentElement.tagName == "parsererror" )
        throw "parsererror" ; if ( s && s.dataFilter ) data = s.dataFilter( data, type );if ( typeof data === "string" ){if ( type == "script" ) jQuery.globalEval( data ); if ( type == "json" )
            data = window[ "eval" ]( "(" + data + ")" ); } return data; }

})
